Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/SelfTest/src/test.cpp	(revision 88)
@@ -372,39 +397,39 @@
   delete in_NRESET;
 
-  delete []  in_EXECUTE_UNIT_OUT_VAL          ;
-  delete [] out_EXECUTE_UNIT_OUT_ACK          ;
-  delete []  in_EXECUTE_UNIT_OUT_CONTEXT_ID   ;
-  delete []  in_EXECUTE_UNIT_OUT_FRONT_END_ID ;
-  delete []  in_EXECUTE_UNIT_OUT_OOO_ENGINE_ID;
-  delete []  in_EXECUTE_UNIT_OUT_PACKET_ID    ;
-//delete []  in_EXECUTE_UNIT_OUT_OPERATION    ;
-  delete []  in_EXECUTE_UNIT_OUT_TYPE         ;
-  delete []  in_EXECUTE_UNIT_OUT_WRITE_RD     ;
-  delete []  in_EXECUTE_UNIT_OUT_NUM_REG_RD   ;
-  delete []  in_EXECUTE_UNIT_OUT_DATA_RD      ;
-  delete []  in_EXECUTE_UNIT_OUT_WRITE_RE     ;
-  delete []  in_EXECUTE_UNIT_OUT_NUM_REG_RE   ;
-  delete []  in_EXECUTE_UNIT_OUT_DATA_RE      ;
-  delete []  in_EXECUTE_UNIT_OUT_EXCEPTION    ;
-  delete []  in_EXECUTE_UNIT_OUT_NO_SEQUENCE  ;
-  delete []  in_EXECUTE_UNIT_OUT_ADDRESS      ;
-
-  delete [] out_WRITE_UNIT_IN_VAL             ;
-  delete []  in_WRITE_UNIT_IN_ACK             ;
-  delete [] out_WRITE_UNIT_IN_CONTEXT_ID      ;
-  delete [] out_WRITE_UNIT_IN_FRONT_END_ID    ;
-  delete [] out_WRITE_UNIT_IN_OOO_ENGINE_ID   ;
-  delete [] out_WRITE_UNIT_IN_PACKET_ID       ;
-//delete [] out_WRITE_UNIT_IN_OPERATION       ;
-  delete [] out_WRITE_UNIT_IN_TYPE            ;
-  delete [] out_WRITE_UNIT_IN_WRITE_RD        ;
-  delete [] out_WRITE_UNIT_IN_NUM_REG_RD      ;
-  delete [] out_WRITE_UNIT_IN_DATA_RD         ;
-  delete [] out_WRITE_UNIT_IN_WRITE_RE        ;
-  delete [] out_WRITE_UNIT_IN_NUM_REG_RE      ;
-  delete [] out_WRITE_UNIT_IN_DATA_RE         ;
-  delete [] out_WRITE_UNIT_IN_EXCEPTION       ;
-  delete [] out_WRITE_UNIT_IN_NO_SEQUENCE     ;
-  delete [] out_WRITE_UNIT_IN_ADDRESS         ;
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_VAL          ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL(out_EXECUTE_UNIT_OUT_ACK          ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_CONTEXT_ID   ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_FRONT_END_ID ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_OOO_ENGINE_ID,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_PACKET_ID    ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+//DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_OPERATION    ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_TYPE         ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_WRITE_RD     ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_NUM_REG_RD   ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_DATA_RD      ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_WRITE_RE     ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_NUM_REG_RE   ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_DATA_RE      ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_EXCEPTION    ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_NO_SEQUENCE  ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+  DELETE2_SC_SIGNAL( in_EXECUTE_UNIT_OUT_ADDRESS      ,_param->_nb_execute_unit,_param->_nb_execute_unit_port[it1]);
+
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_VAL             ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL( in_WRITE_UNIT_IN_ACK             ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_CONTEXT_ID      ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_FRONT_END_ID    ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_OOO_ENGINE_ID   ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_PACKET_ID       ,_param->_nb_write_unit  );
+//DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_OPERATION       ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_TYPE            ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_WRITE_RD        ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_NUM_REG_RD      ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_DATA_RD         ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_WRITE_RE        ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_NUM_REG_RE      ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_DATA_RE         ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_EXCEPTION       ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_NO_SEQUENCE     ,_param->_nb_write_unit  );
+  DELETE1_SC_SIGNAL(out_WRITE_UNIT_IN_ADDRESS         ,_param->_nb_write_unit  );
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Execution_unit_to_Write_unit.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Execution_unit_to_Write_unit.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Execution_unit_to_Write_unit.h	(revision 88)
@@ -65,21 +65,21 @@
 
     // ~~~~~[ Interface "execute_unit_out" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-  public    : SC_IN (Tcontrol_t        )   **  in_EXECUTE_UNIT_OUT_VAL            ;
-  public    : SC_OUT(Tcontrol_t        )   ** out_EXECUTE_UNIT_OUT_ACK            ;
-  public    : SC_IN (Tcontext_t        )   **  in_EXECUTE_UNIT_OUT_CONTEXT_ID     ;
-  public    : SC_IN (Tcontext_t        )   **  in_EXECUTE_UNIT_OUT_FRONT_END_ID   ;
-  public    : SC_IN (Tcontext_t        )   **  in_EXECUTE_UNIT_OUT_OOO_ENGINE_ID  ;
-  public    : SC_IN (Tpacket_t         )   **  in_EXECUTE_UNIT_OUT_PACKET_ID      ;
-//public    : SC_IN (Toperation_t      )   **  in_EXECUTE_UNIT_OUT_OPERATION      ;
-  public    : SC_IN (Ttype_t           )   **  in_EXECUTE_UNIT_OUT_TYPE           ;
-  public    : SC_IN (Tcontrol_t        )   **  in_EXECUTE_UNIT_OUT_WRITE_RD       ;
-  public    : SC_IN (Tgeneral_address_t)   **  in_EXECUTE_UNIT_OUT_NUM_REG_RD     ;
-  public    : SC_IN (Tgeneral_data_t   )   **  in_EXECUTE_UNIT_OUT_DATA_RD        ;
-  public    : SC_IN (Tcontrol_t        )   **  in_EXECUTE_UNIT_OUT_WRITE_RE       ;
-  public    : SC_IN (Tspecial_address_t)   **  in_EXECUTE_UNIT_OUT_NUM_REG_RE     ;
-  public    : SC_IN (Tspecial_data_t   )   **  in_EXECUTE_UNIT_OUT_DATA_RE        ;
-  public    : SC_IN (Texception_t      )   **  in_EXECUTE_UNIT_OUT_EXCEPTION      ;
-  public    : SC_IN (Tcontrol_t        )   **  in_EXECUTE_UNIT_OUT_NO_SEQUENCE    ;
-  public    : SC_IN (Tgeneral_data_t   )   **  in_EXECUTE_UNIT_OUT_ADDRESS        ;
+  public    : SC_IN (Tcontrol_t        )  ***  in_EXECUTE_UNIT_OUT_VAL            ;
+  public    : SC_OUT(Tcontrol_t        )  *** out_EXECUTE_UNIT_OUT_ACK            ;
+  public    : SC_IN (Tcontext_t        )  ***  in_EXECUTE_UNIT_OUT_CONTEXT_ID     ;
+  public    : SC_IN (Tcontext_t        )  ***  in_EXECUTE_UNIT_OUT_FRONT_END_ID   ;
+  public    : SC_IN (Tcontext_t        )  ***  in_EXECUTE_UNIT_OUT_OOO_ENGINE_ID  ;
+  public    : SC_IN (Tpacket_t         )  ***  in_EXECUTE_UNIT_OUT_PACKET_ID      ;
+//public    : SC_IN (Toperation_t      )  ***  in_EXECUTE_UNIT_OUT_OPERATION      ;
+  public    : SC_IN (Ttype_t           )  ***  in_EXECUTE_UNIT_OUT_TYPE           ;
+  public    : SC_IN (Tcontrol_t        )  ***  in_EXECUTE_UNIT_OUT_WRITE_RD       ;
+  public    : SC_IN (Tgeneral_address_t)  ***  in_EXECUTE_UNIT_OUT_NUM_REG_RD     ;
+  public    : SC_IN (Tgeneral_data_t   )  ***  in_EXECUTE_UNIT_OUT_DATA_RD        ;
+  public    : SC_IN (Tcontrol_t        )  ***  in_EXECUTE_UNIT_OUT_WRITE_RE       ;
+  public    : SC_IN (Tspecial_address_t)  ***  in_EXECUTE_UNIT_OUT_NUM_REG_RE     ;
+  public    : SC_IN (Tspecial_data_t   )  ***  in_EXECUTE_UNIT_OUT_DATA_RE        ;
+  public    : SC_IN (Texception_t      )  ***  in_EXECUTE_UNIT_OUT_EXCEPTION      ;
+  public    : SC_IN (Tcontrol_t        )  ***  in_EXECUTE_UNIT_OUT_NO_SEQUENCE    ;
+  public    : SC_IN (Tgeneral_data_t   )  ***  in_EXECUTE_UNIT_OUT_ADDRESS        ;
 
     // ~~~~~[ Interface "write_unit_in" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -107,5 +107,5 @@
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-  private   : std::list<uint32_t> ** _destination; // [nb_execute_unit][nb_thread];
+  private   : std::list<uint32_t> *** _destination; //[nb_execute_unit][nb_execute_unit_port][nb_thread];
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Network/Execution_unit_to_Write_unit/include/Parameters.h	(revision 88)
@@ -26,34 +26,37 @@
   {
     //-----[ fields ]------------------------------------------------------------
-  public : const uint32_t    _nb_execute_unit              ;
-  public : const uint32_t    _nb_write_unit                ;
-  public : const uint32_t    _nb_context                   ;
-  public : const uint32_t    _nb_front_end                 ;
-  public : const uint32_t    _nb_ooo_engine                ;
-  public : const uint32_t    _nb_packet                    ;
-  public : const uint32_t    _size_general_data            ;
-  public : const uint32_t    _size_special_data            ;
-  public : const uint32_t    _nb_general_register          ;
-  public : const uint32_t    _nb_special_register          ;
-  public : const Tpriority_t _priority                     ;
-  public :       bool     ** _table_routing                ; //array [nb_execute_unit][nb_write_unit]
-  public :       bool     ** _table_thread                 ; //array [nb_write_unit][nb_thread]
+  public : uint32_t    _nb_execute_unit              ;
+  public : uint32_t  * _nb_execute_unit_port         ;//[nb_execute_unit]
+  public : uint32_t    _nb_write_unit                ;
+  public : uint32_t    _nb_context                   ;
+  public : uint32_t    _nb_front_end                 ;
+  public : uint32_t    _nb_ooo_engine                ;
+  public : uint32_t    _nb_packet                    ;
+//public : uint32_t    _size_general_data            ;
+//public : uint32_t    _size_special_data            ;
+  public : uint32_t    _nb_general_register          ;
+  public : uint32_t    _nb_special_register          ;
+  public : Tpriority_t _priority                     ;
+  public : bool    *** _table_routing                ; //[nb_execute_unit][nb_execute_unit_port][nb_write_unit]
+  public : bool     ** _table_thread                 ; //[nb_write_unit][nb_thread]
 
-  public : const uint32_t    _size_context_id              ;
-  public : const uint32_t    _size_front_end_id            ;
-  public : const uint32_t    _size_ooo_engine_id           ;
-  public : const uint32_t    _size_packet_id               ;
-  public : const uint32_t    _size_general_register        ;
-  public : const uint32_t    _size_special_register        ;
+  public : uint32_t    _max_nb_execute_unit_port     ;
+//public : uint32_t    _size_context_id              ;
+//public : uint32_t    _size_front_end_id            ;
+//public : uint32_t    _size_ooo_engine_id           ;
+//public : uint32_t    _size_packet_id               ;
+//public : uint32_t    _size_general_register        ;
+//public : uint32_t    _size_special_register        ;
 
-  public : const bool        _have_port_context_id         ;
-  public : const bool        _have_port_front_end_id       ;
-  public : const bool        _have_port_ooo_engine_id      ;
-  public : const bool        _have_port_packet_id          ;
+//public : bool        _have_port_context_id         ;
+//public : bool        _have_port_front_end_id       ;
+//public : bool        _have_port_ooo_engine_id      ;
+//public : bool        _have_port_packet_id          ;
 
-  public : const uint32_t    _nb_thread                    ;
+  public : uint32_t    _nb_thread                    ;
 
     //-----[ methods ]-----------------------------------------------------------
   public : Parameters  (uint32_t    nb_execute_unit              ,
+			uint32_t  * nb_execute_unit_port         ,
 			uint32_t    nb_write_unit                ,
 			uint32_t    nb_context                   ,
@@ -66,8 +69,12 @@
 			uint32_t    nb_special_register          ,
 			Tpriority_t priority                     ,
-			bool     ** table_routing                ,
-			bool     ** table_thread                 );
-  public : Parameters  (Parameters & param) ;
+			bool    *** table_routing                ,
+			bool     ** table_thread                 ,
+                        bool        is_toplevel=false
+                        );
+//   public : Parameters  (Parameters & param) ;
   public : ~Parameters ();
+
+  public :        void            copy       (void);
 
   public :        Parameters_test msg_error  (void);
